import 'dart:async';

abstract class HasModelField<T extends LifecycleAware> implements LifecycleAware {
  T get model;

  @override
  FutureOr start() async {
    if (model != null) {
      model.start();
    }
  }

  @override
  FutureOr dispose() async {
    if (model != null) {
      await model.dispose();
    }
  }
}

abstract class LifecycleAware {
  FutureOr start() {}

  FutureOr dispose() {}
}

typedef FutureOr Dispose();
